/*
    This program demonstrates a simple use of a union.
    Look at the assembly language lising to notice that
    the variable z occupies a simgle 32 bit word of memory.
*/
#include <stdio.h>

typedef union {
int i;
float x;
} int_float;

int_float z;

int main()
{
   z.i = 1;
   printf("z.i = %d\n", z.i);
   printf("z.x = %e\n", z.x);
   printf("the contents of z = %#.8x\n", *(int*)(&z));

   printf("\n");

   z.x = 1;
   printf("z.x = %e\n", z.x);
   printf("z.i = %d\n", z.i);
   printf("the contents of z = %#.8x\n", *(int*)(&z));

   printf("\n");

   z.i = -1;
   printf("z.i = %d\n", z.i);
   printf("z.x = %e\n", z.x);
   printf("the contents of z = %#.8x\n", *(int*)(&z));

   printf("\n");

   z.x = -1;
   printf("z.x = %e\n", z.x);
   printf("z.i = %d\n", z.i);
   printf("the contents of z = %#.8x\n", *(int*)(&z));

   return 0;
}