/*
    Look at the assembly language listing to see
    how the compiler defines global variables in the
    "data segment" or the "bss segment" and local
    variables on the stack, and how the compiler
    handles some simple pointer manipulations.
*/
#include <stdio.h>

int g1 = 11;     // declare an initialized global variable (data segment)
int g2;          // declare an uninitialized global variable (bss segment)

int main()
{
   int x;        // next three lines are just declarations
   int* xp;
   int** xpp;

   int y = 102;  // declaration and definition

   x = 1001;

   xp = &x;

   xpp = &xp;

   y = *xp;

   g1 = **xpp;

   *xp = g2;

   return 0;
}