/*
    This program calls an externally defined function. Suppose that
    we use the definition of test_function() defined in the file
    parameter-passing-b.c. In that case, the output from the printf()
    function is not what we might expect. What causes the output
    from printf() to be what it is? Should the linker have linked the
    object file from this source file with the object file from
    parameter-passing-b.c? What would be needed to prevent this kind
    of bug from creeping into programs?
*/
#include <stdio.h>

// prototype
extern float test_function(float);

int main()
{
   float x = 2.0f;
   float z;
   z = test_function(x);
   printf("z = %f", z);
   return 0;
}