/*
   When you compile this program and then look at the assembly
   language listing, you can see how the compiler implements
   different levels of nested blocks of automatic variables.
   Notice that the compiler allocates space on the stack for
   all of the nested blocks at the same time (as soon as the
   function is entered) but each local variable is not initialized
   until the program enters the variable's block.
*/

int myFunction(int i, char c)
{
   int x = 11;
   {
      int x = 12;
      {
         int x = 13;
         {
            int x = 14;
         }
      }

      {
         int x = 15;
      }
   }
   return 0;
}//main

int main(int argc, char *argv[])
{
   int i = 10;
   char c = 'A';
   myFunction(i, c);
   return 0;
}//main
